#!/usr/bin/env python
# -*- coding: euc-jp -*-

##
# @file BufferBase.py
# @brief Buffer abstract class
# @date $Date: 2007/09/12 $
# @author Noriaki Ando <n-ando@aist.go.jp> and Shinji Kurihara
#
# Copyright (C) 2006-2008
#     Noriaki Ando
#     Task-intelligence Research Group,
#     Intelligent Systems Research Institute,
#     National Institute of
#         Advanced Industrial Science and Technology (AIST), Japan
#     All rights reserved.



##
# @if jp
# @class BufferBase
# @brief BufferBase ݥ饹
# 
# ΥХåեΤݥ󥿡ե饹
# ݥХåե饹ϡʲδؿμ󶡤ʤФʤʤ
# 
# public󥿡եȤưʲΤΤ󶡤롣
#  - write(): Хåե˽񤭹
#  - read(): Хåեɤ߽Ф
#  - length(): ХåեĹ֤
#  - isFull(): ХåեդǤ
#  - isEmpty(): ХåեǤ
# 
# protected󥿡եȤưʲΤΤ󶡤롣
#  - put(): Хåե˥ǡ񤭹
#  - get(): Хåեǡɤ߽Ф
# 
# @since 0.4.0
# 
# @else
# 
# @class BufferBase
# @brief BufferBase abstract class
# 
# This is the abstract interface class for various Buffer.
# 
# @since 0.4.0
# 
# @endif
class BufferBase:
  """
  """


  ##
  # @if jp
  # 
  # @brief ХåեĹ(֥饹)
  # 
  # ХåեĹ<BR>
  # ֥饹Ǥμ
  # 
  # @param self 
  # 
  # @return ХåեĹ
  # 
  # @else
  # 
  # @brief Get the buffer length
  # 
  # @return buffer length
  # 
  # @endif
  def length(self):
    pass


  ##
  # @if jp
  # 
  # @brief Хåե˥ǡ񤭹(֥饹)
  # 
  # Хåե˥ǡ񤭹<BR>
  # ֥饹Ǥμ
  # 
  # @param self 
  # @param value 񤭹оݥǡ
  # 
  # @return ǡ񤭹߷(true:񤭹false:񤭹߼)
  # 
  # @else
  # 
  # @brief Write data into the buffer
  # 
  # @endif
  def write(self, value):
    pass


  ##
  # @if jp
  # 
  # @brief Хåեǡɤ߽Ф(֥饹)
  # 
  # Хåեǡɤ߽Ф<BR>
  # ֥饹Ǥμ
  # 
  # @param self 
  # @param value ɤ߽Фǡ
  # 
  # @return ǡɤ߽Ф(true:ɤ߽Фfalse:ɤ߽Ф)
  # 
  # @else
  # 
  # @brief Read data from the buffer
  # 
  # @endif
  def read(self, value):
    pass


  ##
  # @if jp
  # 
  # @brief Хåեfullå(֥饹)
  # 
  # ХåեfullåѴؿ<BR>
  # ֥饹Ǥμ
  # 
  # @param self 
  # 
  # @return fullå(true:Хåեfullfalse:Хåե)
  # 
  # @else
  # 
  # @brief True if the buffer is full, else false.
  # 
  # @endif
  def isFull(self):
    pass


  ##
  # @if jp
  # 
  # @brief Хåեemptyå(֥饹)
  # 
  # ХåեemptyåѴؿ<BR>
  # ֥饹Ǥμ
  # 
  # @param self 
  # 
  # @return emptyå(true:Хåեemptyfalse:Хåեǡ)
  # 
  # @else
  # 
  # @brief True if the buffer is empty, else false.
  # 
  # @endif
  def isEmpty(self):
    pass


  ##
  # @if jp
  # 
  # @brief Хåե˥ǡǼ(֥饹)
  # 
  # ХåեؤΥǡǼѴؿ<BR>
  # ֥饹Ǥμ
  # 
  # @param self 
  # @param data оݥǡ
  # 
  # @else
  # 
  # @brief Write data into the buffer
  # 
  # @endif
  def put(self, data):
    pass


  ##
  # @if jp
  # 
  # @brief Хåեǡ(֥饹)
  # 
  # Хåե˳Ǽ줿ǡѴؿ<BR>
  # ֥饹Ǥμ
  # 
  # @param self 
  # 
  # @return ǡ
  # 
  # @else
  # 
  # @brief Get data from the buffer
  # 
  # @endif
  def get(self):
    pass


  ##
  # @if jp
  # 
  # @brief ˽񤭹ХåեؤλȤ(֥饹)
  # 
  # 񤭹ߥХåեؤλȼѴؿ<BR>
  # ֥饹Ǥμ
  # 
  # @param self 
  # 
  # @return ν񤭹оݥХåեؤλ
  # 
  # @else
  # 
  # @brief Get the buffer's reference to be written the next
  # 
  # @endif
  def getRef(self):
    pass


##
# @if jp
# @class NullBuffer
# @brief ߡХåե饹
# 
# ХåեĹΥߡХåե饹
# 
# @param DataType Хåե˳Ǽǡ
# 
# @since 0.4.0
# 
# @else
# 
# @endif
class NullBuffer(BufferBase):
  """
  """



  ##
  # @if jp
  # 
  # @brief 󥹥ȥ饯
  # 
  # 󥹥ȥ饯
  # ХåեĹ()ǽ롣
  # 
  # @param self 
  # @param size ХåեĹ(ǥե:None̵)
  # 
  # @else
  # 
  # @endif
  def __init__(self, size=None):
    if size is None:
      size=1
    self._length = 1
    self._data = None
    self._is_new = False
    self._inited = False


  ##
  # @if jp
  # 
  # @brief 󥹥ȥ饯
  # 
  # 󥹥ȥ饯
  # 
  # @param self 
  # @param data Ǽǡ
  # 
  # @else
  # 
  # @endif
  def init(self, data):
    self.put(data)


  ##
  # @if jp
  # 
  # @brief Хåեν
  # 
  # Хåեν¹Ԥ롣
  # 
  # @param self 
  # 
  # @else
  # 
  # @endif
  def clear(self):
    self._inited = False


  ##
  # @if jp
  # 
  # @brief ХåեĹ()
  # 
  # ХåեĹ롣(ˣ֤)
  # 
  # @param self 
  # 
  # @return ХåեĹ()
  # 
  # @else
  # 
  # @brief Get the buffer length
  # 
  # @return buffer length(always 1)
  # 
  # @endif
  def length(self):
    return 1


  ##
  # @if jp
  # 
  # @brief Хåե˥ǡ񤭹
  # 
  # Ϳ줿ǡХåե˽񤭹ࡣ
  # 
  # @param self 
  # @param value 񤭹оݥǡ
  # 
  # @return ǡ񤭹߷(true:񤭹false:񤭹߼)
  # 
  # @else
  # 
  # @brief Write data into the buffer
  # 
  # @endif
  def write(self, value):
    self.put(value)
    return True


  ##
  # @if jp
  # 
  # @brief Хåեǡɤ߽Ф
  # 
  # Хåե˳Ǽ줿ǡɤ߽Ф
  # 
  # @param self 
  # @param value ɤ߽Фǡ
  # 
  # @return ǡɤ߽Ф(true:ɤ߽Фfalse:ɤ߽Ф)
  # 
  # @else
  # 
  # @brief Read data from the buffer
  # 
  # @endif
  def read(self, value):
    if not self._inited:
      return False
    value[0] = self.get()
    return True


  ##
  # @if jp
  # 
  # @brief Хåեfullå
  # 
  # Хåեfullå롣(false֤)
  # 
  # @param self 
  # 
  # @return fullå(false)
  # 
  # @else
  # 
  # @brief Always false.
  # 
  # @endif
  def isFull(self):
    return False


  ##
  # @if jp
  # 
  # @brief Хåեemptyå
  # 
  # Хåեemptyå롣(false֤)
  # ׳ǧ
  # 
  # @param self 
  # 
  # @return emptyå(false)
  # 
  # @else
  # 
  # @brief Always false.
  # 
  # @endif
  def isEmpty(self):
    return not self._inited


  ##
  # @if jp
  # 
  # @brief ǿǡǧ
  # 
  # ߤΥХåե֤˳ǼƤǡǿǡǧ롣
  # 
  # @param self 
  # 
  # @return ǿǡǧ
  #            ( true:ǿǡǡϤޤɤ߽ФƤʤ
  #             false:Υǡǡϴɤ߽ФƤ)
  # 
  # @else
  # 
  # @endif
  def isNew(self):
    return self._is_new


  ##
  # @if jp
  # 
  # @brief Хåե˥ǡǼ
  # 
  # Ϳ줿ǡХåե˳Ǽ롣
  # 
  # @param self 
  # @param data оݥǡ
  # 
  # @else
  # 
  # @brief Write data into the buffer
  # 
  # @endif
  def put(self, data):
    self._data = data
    self._is_new = True
    self._inited = True


  ##
  # @if jp
  # 
  # @brief Хåեǡ
  # 
  # Хåե˳Ǽ줿ǡ롣
  # 
  # @param self 
  # 
  # @return ǡ
  # 
  # @else
  # 
  # @brief Get data from the buffer
  # 
  # @endif
  def get(self):
    self._is_new = False
    return self._data


  ##
  # @if jp
  # 
  # @brief ˽񤭹ХåեؤλȤ
  # 
  # 񤭹ߥХåեؤλȤ롣
  # ܥХåեǤϥХåեĹϸǣǤ뤿ᡤ
  # Ʊ֤ؤλȤ֤
  # 
  # @param self 
  # 
  # @return ν񤭹оݥХåեؤλ()
  # 
  # @else
  # 
  # @brief Get the buffer's reference to be written the next
  # 
  # @endif
  def getRef(self):
    return self._data
