#!/usr/bin/env python
# -*- coding: euc-jp -*- 

##
# @file ConfigAdmin.py
# @brief Configuration Administration classes
# @date $Date: 2007/09/04$
# @author Noriaki Ando <n-ando@aist.go.jp> and Shinji Kurihara
# 
# Copyright (C) 2007-2008
#     Task-intelligence Research Group,
#     Intelligent Systems Research Institute,
#     National Institute of
#         Advanced Industrial Science and Technology (AIST), Japan
#     All rights reserved.



import copy
import OpenRTM


##
# @if jp
# @class ConfigBase
# @brief ConfigBase ݥ饹
# 
# Ƽ拾ե졼ݻ뤿ݥ饹
# ݥե졼󥯥饹ϡʲδؿμ󶡤ʤ
# Фʤʤ
# 
# public󥿡եȤưʲΤΤ󶡤롣
#  - update(): ե졼ѥ᡼ͤι
# 
# @since 0.4.0
# 
# @else
# 
# @endif
class ConfigBase:



  ##
  # @if jp
  # 
  # @brief 󥹥ȥ饯
  # 
  # 󥹥ȥ饯
  # 
  # @param self 
  # @param name ե졼̾
  # @param def_val ʸΥǥե
  # 
  # @else
  # 
  # @endif
  def __init__(self, name, def_val):
    self.name = name
    self.default_value = def_val


  ##
  # @if jp
  # 
  # @brief ե졼ѥ᡼͹Ѵؿ(֥饹)
  # 
  # ե졼ͤǥե졼ѥ᡼򹹿
  # δؿ<BR>
  # ֥饹Ǥμ
  # 
  # @param self 
  # @param val ѥ᡼ͤʸɽ
  # 
  # @return 
  # 
  # @else
  # 
  # @endif
  def update(self, val):
    pass



##
# @if jp
# @class Config
# @brief Config 饹
# 
# ե졼ѥ᡼ξݻ륯饹
# ե졼Υǡꤵ줿ǡʸѴ
# Ѵؿꤹ롣
# 
# @since 0.4.0
# 
# @else
# 
# @endif
class Config(ConfigBase):



  ##
  # @if jp
  # 
  # @brief 󥹥ȥ饯
  # 
  # 󥹥ȥ饯
  # 
  # @param self 
  # @param name ե졼ѥ᡼̾
  # @param var ե졼ѥ᡼Ǽѿ
  # @param def_val ʸΥǥե
  # @param trans ʸѴؿ(ǥե:None)
  # 
  # @else
  # 
  # @endif
  def __init__(self, name, var, def_val, trans=None):
    ConfigBase.__init__(self, name, def_val)
    self._var = var
    if trans:
      self._trans = trans
    else:
      self._trans = OpenRTM.stringTo


  ##
  # @if jp
  # 
  # @brief Хɥѥ᡼ͤ򹹿
  # 
  # ե졼ͤǥե졼ѥ᡼򹹿
  # 
  # @param self 
  # @param val ѥ᡼ͤʸɽ
  # 
  # @return (:true:false)
  # 
  # @else
  # 
  # @endif
  def update(self, val):
    if self._trans(self._var, val):
      return True
    self._trans(self._var, self._default_value)
    return False



##
# @if jp
# @class ConfigAdmin
# @brief ConfigAdmin 饹
# 
# Ƽ拾ե졼륯饹
# 
# @since 0.4.0
# 
# @else
# 
# @endif
class ConfigAdmin:
  """
  """



  ##
  # @if jp
  # 
  # @brief 󥹥ȥ饯
  # 
  # 󥹥ȥ饯
  # 
  # @param self 
  # @param configsets оݥץѥƥ̾
  # 
  # @else
  # 
  # @endif
  def __init__(self, configsets):
    self._configsets = configsets
    self._activeId   = "default"
    self._active     = True
    self._changed    = False
    self._params     = []
    self._emptyconf  = OpenRTM.Properties()
    self._newConfig  = []


  ##
  # @if jp
  # 
  # @brief ǥȥ饯
  # 
  # ǥȥ饯
  # ꤵƤѥ᡼롣
  # 
  # @param self 
  # 
  # @else
  # 
  # @endif
  def __del__(self):
    del self._params


  ##
  # @if jp
  # 
  # @brief ե졼ѥ᡼
  # 
  # ե졼ѥ᡼ѿХɤ
  # ꤷ̾ΤΥե졼ѥ᡼¸ߤ
  # false֤
  # 
  # @param self 
  # @param param_name ե졼ѥ᡼̾
  # @param var ե졼ѥ᡼Ǽѿ
  # @param def_val ե졼ѥ᡼ǥե
  # @param trans ե졼ѥ᡼ʸѴѴؿ
  #             (ǥե:None)
  # 
  # @return (:true꼺:false)
  # 
  # @else
  # 
  # @endif
  def bindParameter(self, param_name, var, def_val, trans=None):
    if trans is None:
      trans = OpenRTM.stringTo
    
    if self.isExist(param_name):
      return False

    if not OpenRTM.stringTo(var, def_val):
      return False
    
    self._params.append(Config(param_name, var, def_val, trans))
    return True


  ##
  # @if jp
  # 
  # @brief ե졼ѥ᡼ι
  # 
  # ˤäưʲνԤ
  # - config_setΤߤꤵƤ
  #     ꤷIDΥե졼󥻥åȤꤷͤǡ
  #     ե졼ѥ᡼ͤ򹹿롣
  #     ꤷIDΥե졼󥻥åȤ¸ߤʤϡ
  #     ⤻˽λ롣
  # - config_setconfig_paramꤵƤ
  #     ꤷѥΥե졼ꤷͤǡ
  #     ե졼ѥ᡼ͤ򹹿롣
  # - config_setconfig_paramξȤꤵƤʤ
  #     ե졼󥻥åȤƤˡ
  #     ߥƥ֤ˤʤäƤ륳ե졼ꤷͤǡ
  #     ե졼ѥ᡼ͤ򹹿롣
  #     νǤιϡƥ֤ȤʤäƤ륳ե졼󥻥å
  #     ¸ߤƤ硢ι饳ե졼󥻥åȤƤ
  #     ƤΤ߼¹Ԥ롣
  # 
  # @param self 
  # @param config_set ե졼̾Ρ.׶ڤǺǸǤ
  #                   ̾
  # @param config_param ե졼󥻥åȤκǸ̾
  # 
  # @else
  # 
  # @endif
  def update(self, config_set=None, config_param=None):
    # update(const char* config_set)
    if config_set and config_param is None:
      if self._configsets.hasKey(config_set) is None:
        return
      prop = self._configsets.getNode(config_set)
      for i in range(len(self._params)):
        if prop.hasKey(self._params[i].name):
          self._params[i].update(prop.getProperty(self._params[i].name))

    # update(const char* config_set, const char* config_param)
    if config_set and config_param:
      key = config_set
      key = key+"."+config_param
      for conf in self._params:
        if conf.name == config_param:
          conf.update(self._configsets.getProperty(key))
          return

    # update()
    if config_set is None and config_param is None:
      if self._changed and self._active:
        self.update(self._activeId)
        self._changed = False
      return


  ##
  # @if jp
  # 
  # @brief ե졼ѥ᡼¸߳ǧ
  # 
  # ꤷ̾Τĥե졼ѥ᡼¸ߤ뤫ǧ롣
  # 
  # @param self 
  # @param param_name ե졼ѥ᡼̾Ρ
  # 
  # @return ¸߳ǧ(ѥ᡼:trueѥ᡼ʤ:false)
  # 
  # @else
  # 
  # @endif
  def isExist(self, param_name):
    if not self._params:
      return False
    
    for conf in self._params:
      if conf.name == param_name:
        return True

    return False


  ##
  # @if jp
  # 
  # @brief ե졼ѥ᡼ѹǧ
  # 
  # ե졼ѥ᡼ѹ줿ǧ롣
  # 
  # @param self 
  # 
  # @return ѹǧ(ѹ:trueѹʤ:false)
  # 
  # @else
  # 
  # @endif
  def isChanged(self):
    return self._changed


  ##
  # @if jp
  # 
  # @brief ƥ֡ե졼󥻥åIDμ
  # 
  # ߥƥ֤ʥե졼󥻥åȤID롣
  # 
  # @param self 
  # 
  # @return ƥ֡ե졼󥻥åID
  # 
  # @else
  # 
  # @endif
  def getActiveId(self):
    return self._activeId


  ##
  # @if jp
  # 
  # @brief ե졼󥻥åȤ¸߳ǧ
  # 
  # ꤷե졼󥻥åȤ¸ߤ뤫ǧ롣
  # 
  # @param self 
  # @param config_id ǧоݥե졼󥻥åID
  # 
  # @return ¸߳ǧ(ꤷConfigSet:trueʤ:false)
  # 
  # @else
  # 
  # @endif
  def haveConfig(self, config_id):
    if self._configsets.hasKey(config_id) is None:
      return False
    else:
      return True


  ##
  # @if jp
  # 
  # @brief ե졼󥻥åȤΥƥֲǧ
  # 
  # ե졼󥻥åȤƥֲƤ뤫ǧ롣
  # 
  # @param self 
  # 
  # @return ֳǧ(ƥ־:true󥢥ƥ־:false)
  # 
  # @else
  # 
  # @endif
  def isActive(self):
    return self._active


  ##
  # @if jp
  # 
  # @brief ե졼󥻥åȤμ
  # 
  # ꤵƤե졼󥻥åȤ롣
  # 
  # @param self 
  # 
  # @return ե졼󥻥å
  # 
  # @else
  # 
  # @endif
  def getConfigurationSets(self):
    return self._configsets.getLeaf()


  ##
  # @if jp
  # 
  # @brief ꤷIDΥե졼󥻥åȤμ
  # 
  # IDǻꤷե졼󥻥åȤ롣
  # ꤷե졼󥻥åȤ¸ߤʤϡ
  # Υե졼󥻥åȤ֤
  # 
  # @param self 
  # @param config_id оݥե졼󥻥åȤID
  # 
  # @return ե졼󥻥å
  # 
  # @else
  # 
  # @endif
  def getConfigurationSet(self, config_id):
    prop = self._configsets.getNode(config_id)
    if prop is None:
      return self._emptyconf
    return prop


  ##
  # @if jp
  # 
  # @brief ꤷץѥƥΥե졼󥻥åȤؤɲ
  # 
  # ꤷץѥƥIDǻꤷե졼󥻥åȤɲä롣
  # ꤷIDȰפ륳ե졼󥻥åȤ¸ߤʤϡ
  # false ֤
  # 
  # @param self 
  # @param config_id ɲоݥե졼󥻥åȤID
  # @param config_set ɲäץѥƥ
  # 
  # @return ɲý¹Է(ɲ:trueɲü:false)
  # 
  # @else
  # 
  # @endif
  def setConfigurationSetValues(self, config_id, config_set):
    if config_set.getName() != config_id:
      return False
    if not self._configsets.hasKey(config_id):
      return False

    p = self._configsets.getNode(config_id)
    if p is None:
      return False
    p.mergeProperties(config_set)

    self._changed = True
    self._active  = False
    return True


  ##
  # @if jp
  # 
  # @brief ƥ֡ե졼󥻥åȤ
  # 
  # ߥƥ֤ȤʤäƤ륳ե졼󥻥åȤ롣
  # ƥ֤ȤʤäƤ륳ե졼󥻥åȤ¸ߤʤϡ
  # Υե졼󥻥å ֤
  # 
  # @param self 
  # 
  # @return ƥ֡ե졼󥻥å
  # 
  # @else
  # 
  # @endif
  def getActiveConfigurationSet(self):
    p = self._configsets.getNode(self._activeId)
    if p is None:
      return self._emptyconf

    return p


  ##
  # @if jp
  # 
  # @brief ե졼󥻥åȤͤɲ
  # 
  # ե졼󥻥åȤͤɲä롣
  # 
  # @param self 
  # @param configset ɲäץѥƥ
  # 
  # @return ɲý(ɲ:trueɲü:false)
  # 
  # @else
  # 
  # @endif
  def addConfigurationSet(self, configset):
    if self._configsets.hasKey(configset.getName()):
      return False
    node = configset.getName()

    # Create node
    self._configsets.createNode(node)

    p = self._configsets.getNode(node)
    p.mergeProperties(configset)
    self._newConfig.append(node)

    self._changed = True
    self._active  = False

    return True


  ##
  # @if jp
  # 
  # @brief ե졼󥻥åȤκ
  # 
  # ꤷIDΥե졼󥻥åȤ롣
  # ꤷIDΥե졼󥻥åȤ¸ߤʤϡ
  # false֤
  # 
  # @param self 
  # @param config_id оݥե졼󥻥åȤID
  # 
  # @return (:true:false)
  # 
  # @else
  # 
  # @endif
  def removeConfigurationSet(self, config_id):
    idx = 0
    for conf in self._newConfig:
      if conf == config_id:
        break
      idx += 1

    if idx == len(self._newConfig):
      return False

    p = self._configsets.getNode(config_id)
    if p:
      p.getRoot().removeNode(config_id)
      del p

    del self._newConfig[idx]

    self._changed = True
    self._active  = False

    return True


  ##
  # @if jp
  # 
  # @brief ե졼󥻥åȤΥƥֲ
  # 
  # ꤷIDΥե졼󥻥åȤ򥢥ƥֲ롣
  # ꤷIDΥե졼󥻥åȤ¸ߤʤϡ
  # false֤
  # 
  # @param self 
  # @param config_id оݥե졼󥻥åȤID
  # 
  # @return ƥֽ(:true:false)
  # 
  # @else
  # 
  # @endif
  def activateConfigurationSet(self, config_id):
    if config_id is None:
      return False
    if not self._configsets.hasKey(config_id):
      return False
    self._activeId = config_id
    self._active   = True
    self._changed  = True
    return True
