#!/usr/bin/env python
# -*- coding: euc-jp -*-

##
# @file InPort.py
# @brief InPort template class
# @date $Date: 2007/09/20 $
# @author Noriaki Ando <n-ando@aist.go.jp> and Shinji Kurihara
# 
# Copyright (C) 2003-2008
#     Task-intelligence Research Group,
#     Intelligent Systems Research Institute,
#     National Institute of
#         Advanced Industrial Science and Technology (AIST), Japan
#     All rights reserved.

from omniORB import any
import sys
import traceback

import OpenRTM

TIMEOUT_TICK_USEC = 10.0
USEC_PER_SEC      = 1000000.0
TIMEOUT_TICK_SEC = TIMEOUT_TICK_USEC/USEC_PER_SEC


import time



##
# @if jp
# @class Time
# @brief ִѥ饹
# 
# ꤷͤݻ뤿Υ饹
# 
# @since 0.4.1
# 
# @else
# 
# @endif
class Time:



  ##
  # @if jp
  # @brief 󥹥ȥ饯
  #
  # 󥹥ȥ饯
  #
  # @param self
  #
  # @else
  # @brief Constructor.
  #
  # Constructor.
  #
  # @param self
  #
  # @endif
  def __init__(self):
    tm = time.time()
    tm_f       = tm - int(tm)     # μФ
    self.sec   = int(tm - tm_f)   # μФ
    self.usec  = int(tm_f * USEC_PER_SEC) # sec -> usec (micro second)



##
# @if jp
#
# @class InPort
#
# @brief InPort 饹
# 
# InPort μ饹
# InPort ˥󥰥Хåե줿ǡ缡
# Υ󥰥Хåե˳Ǽ롣󥰥ХåեΥϥǥեȤ64
# ʤäƤ뤬󥹥ȥ饯ˤꥵꤹ뤳ȤǤ롣
# ǡϥե饰ˤä̤ɡɾ֤졢isNew(), getNewDataLen()
# getNewList(), getNewListReverse() Υ᥽åɤˤϥɥ󥰤뤳Ȥ
# Ǥ롣
#
# @since 0.2.0
#
# @else
#
# @class InPort
#
# @brief InPort template class
#
# This class template provides interfaces to input port.
# Component developer can define input value, which act as input
# port from other components, using this template.
# This is class template. This class have to be incarnated class as port
# value types. This value types are previously define RtComponent IDL.
# ex. type T: TimedFload, TimedLong etc... 
#
# @since 0.2.0
#
# @endif
class InPort:
  """
  """



  ##
  # @if jp
  #
  # @brief 󥹥ȥ饯
  #
  # 󥹥ȥ饯
  #
  # @param self
  # @param name InPort ̾InPortBase:name() ˤ껲Ȥ롣
  # @param value  InPort ˥Хɤѿ
  # @param buffer_ InPort ݻХåե
  # @param read_block ɹ֥åե饰
  #        ǡɹ̤ɥǡʤ硢Υǡޤǥ֥å
  #        ɤ(ǥե:False)
  # @param write_block ֥åե饰
  #        ǡ˥ХåեեǤä硢Хåե˶Ǥ
  #        ޤǥ֥å뤫ɤ(ǥե:False)
  # @param read_timeout ɹ֥åꤷƤʤΡǡɼ西
  #        Ȼ(ߥ)(ǥե:0)
  # @param write_timeout ֥åꤷƤʤΡǡ
  #        Ȼ(ߥ)(ǥե:0)
  #
  # @else
  #
  # @brief A constructor.
  #
  # Setting channel name and registering channel value.
  #
  # @param self
  # @param name A name of the InPort. This name is referred by
  #             InPortBase::name().
  # @param value A channel value related with the channel.
  # @param buffer_ Buffer length of internal ring buffer of InPort 
  # @param read_block
  # @param write_block
  # @param read_timeout
  # @param write_timeout
  #
  # @endif
  def __init__(self, name, value, buffer_,
         read_block=False, write_block=False,
         read_timeout=0, write_timeout = 0):
    self._buffer         = buffer_
    self._name           = name
    self._value          = value
    self._readBlock      = read_block
    self._readTimeout    = read_timeout
    self._writeBlock     = write_block
    self._writeTimeout   = write_timeout
    self._OnWrite        = None
    self._OnWriteConvert = None
    self._OnRead         = None
    self._OnReadConvert  = None
    self._OnOverflow     = None
    self._OnUnderflow    = None


  ##
  # @if jp
  # @brief ǿǡǧ
  #
  # ߤΥХåե֤˳ǼƤǡǿǡǧ롣
  #
  # @param self
  #
  # @return ǿǡǧ
  #            ( true:ǿǡǡϤޤɤ߽ФƤʤ
  #             false:Υǡǡϴɤ߽ФƤ)
  #
  # @else
  #
  # @endif
  def isNew(self):
    return self._buffer.isNew()


  ##
  # @if jp
  # @brief ݡ̾Τ롣
  #
  # ݡ̾Τ롣
  #
  # @param self
  #
  # @return ݡ̾
  #
  # @else
  #
  # @endif
  def name(self):
    return self._name


  ##
  # @if jp
  #
  # @brief DataPort ͤ񤭹
  #
  # DataPort ͤ񤭹ࡣ
  #
  # - Хåե󥯥 OnWrite åȤƤ硢
  #   InPort ݻХåե˽񤭹 OnWrite ƤФ롣
  # - InPort ݻХåեСե򸡽ФǤХåեǤꡢ
  #   ġ񤭹ݤ˥ХåեСե򸡽Ф硢
  #   Хåե󥯥 OnOverflow ƤФ롣
  # - Хåե󥯥 OnWriteConvert åȤƤ硢
  #   Хåե񤭹߻ˡOnWriteConvert  operator()() ͤ
  #   Хåե˽񤭹ޤ롣
  # - setWriteTimeout() ˤ񤭹߻ΥॢȤꤵƤ硢
  #   ॢȻ֤Хåեե֤ΤԤ
  #   OnOverflowåȤƤФƤӽФ롣
  #
  # @param self
  # @param value оݥǡ
  #
  # @return (:true:false)
  #
  # @else
  #
  # @brief 
  #
  # @endif
  def write(self, value):
    if self._OnWrite:
      self._OnWrite(value)

    timeout = self._writeTimeout

    tm_pre = Time()

    # blocking and timeout wait
    while self._writeBlock and self._buffer.isFull():
      if self._writeTimeout < 0:
        time.sleep(TIMEOUT_TICK_SEC)
        continue

      # timeout wait
      tm_cur = Time()

      sec  = tm_cur.sec - tm_pre.sec
      usec = tm_cur.usec - tm_pre.usec

      timeout -= (sec * USEC_PER_SEC + usec)

      if timeout < 0:
        break

      tm_pre = tm_cur
      time.sleep(TIMEOUT_TICK_USEC)

    if self._buffer.isFull() and self._OnOverflow:
      self._OnOverflow(value)
      return False

    if not self._OnWriteConvert:
      self._buffer.put(value)
    else:
      self._buffer.put(self._OnWriteConvert(value))

    return True


  ##
  # @if jp
  #
  # @brief DataPort ͤɤ߽Ф
  #
  # DataPort ͤɤ߽Ф
  #
  # - Хåե󥯥 OnRead åȤƤ硢
  #   DataPort ݻХåեɤ߽Ф OnRead ƤФ롣
  # - DataPort ݻХåեե򸡽ФǤХåեǡ
  #   ġɤ߽Фݤ˥Хåեե򸡽Ф硢
  #   Хåե󥯥 OnUnderflow ƤФ롣
  # - Хåե󥯥 OnReadConvert åȤƤ硢
  #   Хåե񤭹߻ˡOnReadConvert  operator()() ͤ
  #   read()ͤȤʤ롣
  # - setReadTimeout() ˤɤ߽ФΥॢȤꤵƤ硢
  #   Хåեե֤ޤǥॢȻ֤Ԥ
  #   OnUnderflowåȤƤФƤӽФ
  #
  # @param self
  #
  # @return ɤ߽Фǡ
  #
  # @else
  #
  # @brief [CORBA interface] Put data on InPort
  #
  # @endif
  def read(self):
    if self._OnRead:
      self._OnRead()

    timeout = self._readTimeout

    tm_pre = Time()

    # blocking and timeout wait
    while self._readBlock and self._buffer.isEmpty():
      if self._readTimeout < 0:
        time.sleep(TIMEOUT_TICK_SEC)
        continue

      # timeout wait
      tm_cur = Time()

      sec  = tm_cur.sec - tm_pre.sec
      usec = tm_cur.usec - tm_pre.usec
      
      timeout -= (sec * USEC_PER_SEC + usec)

      if timeout < 0:
        break

      tm_pre = tm_cur
      time.sleep(TIMEOUT_TICK_SEC)

    if self._buffer.isEmpty():
      if self._OnUnderflow:
        self._value = self._OnUnderflow()
      return self._value

    if not self._OnReadConvert:
      self._value = self._buffer.get()
      return self._value
    else:
      self._value = self._OnReadConvert(self._buffer.get())
      return self._value

    # never comes here
    return self._value


  ##
  # @if jp
  #
  # @brief InPort Υ󥰥Хåեͤ(֥饹)
  #
  # InPort Υ󥰥Хåեͤꤷͤǽ롣<BR>
  # ֥饹Ǥμ
  #
  # @param self
  # @param value оݥǡ
  #
  # @else
  #
  # @brief Initialize ring buffer value of InPort
  #
  # @endif
  def init(self, value):
    pass


  ##
  # @if jp
  #
  # @brief Хɤ줿ѿ InPort Хåեκǿͤɤ߹
  #
  # Хɤ줿ǡ InPort κǿͤɤ߹ࡣ
  # 󥹥ȥ饯ѿ InPort ХɤƤʤФʤʤ
  # Υ᥽åɤϥݥ⡼եå˻ѤȤƤ뤿ᡢ
  # ˰¸ʤͤȤʤäƤ롣
  #
  # @param self
  #
  # @else
  #
  # @brief Read into bound T-type data from current InPort
  #
  # @endif
  def update(self):
    try:
      self._value = self._buffer.get()
    except:
      if self._OnUnderflow:
        self._OnUnderflow()
      else:
        traceback.print_exception(*sys.exc_info())
        
    return


  ##
  # @if jp
  #
  # @brief ̤ɤοǡ
  #
  # Хåե̤ɥǡ롣
  #
  # @param self
  #
  # @return ̤ɥǡ
  #
  # @else
  #
  # @brief Get number of new data to be read.
  #
  # @endif
  def getNewDataLen(self):
    return self._buffer.new_data_len()


  ##
  # @if jp
  #
  # @brief ̤ɤοǡ
  #
  # Хåե̤ɥǡꥹȤ롣
  #
  # @param self
  #
  # @return ̤ɥǡꥹ
  #
  # @else
  #
  # \brief Get new data to be read.
  #
  # @endif
  def getNewList(self):
    return self._buffer.get_new_list()


  ##
  # @if jp
  #
  # @brief ̤ɤοǡս(->)Ǽ
  #
  # Хåե̤ɥǡս(->)ǥꥹȲ롣
  #
  # @param self
  #
  # @return ̤ɥǡꥹ
  #
  # @else
  #
  # \brief Get new data to be read.
  #
  # @endif
  def getNewListReverse(self):
    return self._buffer.get_new_rlist()


  ##
  # @if jp
  #
  # @brief InPort ХåեإǡϻΥХå
  #
  # InPort ĥХåե˥ǡput줿Ȥ˸ƤФ륳Хå
  # ֥Ȥꤹ롣ꤵ륳Хå֥Ȥ
  #  value  void  __call__ ؿƤɬפ롣
  #
  # <pre>
  # class MyOnWrite:
  #     def __call__(self, value):
  #       <br>
  # </pre>
  # Τ褦˥Хå֥Ȥ<br> 
  # m_inport.setOnWrite(new MyOnWrite());<br>
  # Τ褦˥Хå֥Ȥ򥻥åȤ롣
  #
  # @param self
  # @param on_write оݥХå֥
  #
  # @else
  #
  # @brief Get new data to be read.
  #
  # @endif
  def setOnWrite(self, on_write):
    self._OnWrite = on_write


  ##
  # @if jp
  #
  # @brief InPort Хåեإǡ񤭹߻ΥХå
  #
  # InPort ĥХåե˥ǡ񤭹ޤ˸ƤФ륳Хå
  # ֥Ȥꤹ롣ХåեˤϥХå֥Ȥ
  # ͤꤵ롣
  # 
  # @param self
  # @param on_wconvert оݥХå֥
  #
  # @else
  #
  # @endif
  def setOnWriteConvert(self, on_wconvert):
    self._OnWriteConvert = on_wconvert


  ##
  # @if jp
  #
  # @brief InPort Хåեإǡɤ߹߻ΥХå
  #
  # InPort ĥХåեǡɤ߹ޤľ˸ƤФ륳Хå
  # ֥Ȥꤹ롣
  # 
  # @param self
  # @param on_read оݥХå֥
  #
  # @else
  #
  # @endif
  def setOnRead(self, on_read):
    self._OnRead = on_read


  ##
  # @if jp
  #
  # @brief InPort Хåեإǡɤ߽ФΥХå
  #
  # InPort ĥХåեǡɤ߽Фݤ˸ƤФ륳Хå
  # ֥Ȥꤹ롣Хå֥Ȥͤread()᥽å
  # θƽз̤Ȥʤ롣
  # 
  # @param self
  # @param on_rconvert оݥХå֥
  #
  # @else
  #
  # @endif
  def setOnReadConvert(self, on_rconvert):
    self._OnReadConvert = on_rconvert


  ##
  # @if jp
  #
  # @brief InPort ХåեإХåեСեΥХå
  #
  # InPort ĥХåեǥХåեСեФ줿ݤ˸ƤӽФ
  # Хå֥Ȥꤹ롣
  # 
  # @param self
  # @param on_overflow оݥХå֥
  #
  # @else
  #
  # @endif
  def setOnOverflow(self, on_overflow):
    self._OnOverflow = on_overflow


  ##
  # @if jp
  #
  # @brief InPort ХåեإХåեեΥХå
  #
  # InPort ĥХåեǥХåեեФ줿ݤ˸ƤӽФ
  # Хå֥Ȥꤹ롣
  # 
  # @param self
  # @param on_underflow оݥХå֥
  #
  # @else
  #
  # @endif
  def setOnUnderflow(self, on_underflow):
    self._OnUnderflow = on_underflow


  ##
  # @if jp
  #
  # @brief ǡ̾ѥ᥽å
  #
  # ǡη̾뤿ᡢInPortCorbaProviderƤФ롣
  # 
  # @param self
  #
  # @return ХåեꤵƤǡη̾
  #
  # @else
  #
  # @endif
  def getPortDataType(self):
    val = any.to_any(self._value)
    return str(val.typecode().name())
