#!/usr/bin/env python
# -*- coding: euc-jp -*-


##
# @file PortCallBack.py
# @brief PortCallBack class
# @date $Date: 2007/09/20 $
# @author Noriaki Ando <n-ando@aist.go.jp> and Shinji Kurihara
# 
# Copyright (C) 2006-2008
#     Noriaki Ando
#     Task-intelligence Research Group,
#     Intelligent Systems Research Institute,
#     National Institute of
#         Advanced Industrial Science and Technology (AIST), Japan
#     All rights reserved.
 

#============================================================
# callback functor base classes
#

##
# @if jp
# @class OnWrite
# @brief write() ΥХå饹(֥饹)
#
# DataPortΥХåե˥ǡwrite()ľ˸ƤӽФ륳Хå<BR>
# ֥饹Ǥμ
#
# @param DataType Хåե˽񤭹ǡ
#
# @since 0.4.0
#
# @else
# @class OnPut
# @brief OnPut abstract class
#
# @endif
class OnWrite:
  def __call__(self, value):
    pass



##
# @if jp
# @class OnWriteConvert
# @brief write() ΥǡѴХå饹(֥饹)
#
# InPort/OutPortΥХåե˥ǡ write()˸ƤӽФ<BR>
# ֥饹Ǥμ
# Хåѥ󥿡ե
# ΥХåͤХåե˳Ǽ롣
#
# @since 0.4.0
#
# @else
# @class OnWriteConvert
# @brief OnWriteConvert abstract class
#
# @endif
class OnWriteConvert:
  def __call__(self,value):
    pass



##
# @if jp
# @class OnRead
# @brief read() ΥХå饹(֥饹)
#
# InPort/OutPortΥХåեǡ read()ľ˸ƤӽФ
# Хåѥ󥿡ե<BR>
# ֥饹Ǥμ
#
# @since 0.4.0
#
# @else
# @class OnRead
# @brief OnRead abstract class
#
# @endif
class OnRead:
  def __call__(self):
    pass



##
# @if jp
# @class OnReadConvert
# @brief read() ΥǡѴХå饹(֥饹)
#
# InPort/OutPortΥХåեǡ read()ݤ˸ƤӽФ
# Хåѥ󥿡ե
# ΥХåͤread()ͤȤʤ롣<BR>
# ֥饹Ǥμ
#
# @since 0.4.0
#
# @else
# @class OnReadConvert
# @brief OnReadConvert abstract class
#
# @endif
class OnReadConvert:
  def __call__(self,value):
    pass



##
# @if jp
# @class OnOverflow
# @brief ХåեСեΥХå饹(֥饹)
#
# InPort/OutPortΥХåե˥ǡput()ХåեСե
# ˸ƤФ륳Хå᥽åɡ<BR>
# ֥饹Ǥμ
#
# @since 0.4.0
#
# @else
# @class OnOverflow
# @brief OnOverflow abstract class
#
# @endif
class OnOverflow:
  def __call__(self,value):
    pass


##
# @if jp
# @class OnUnderflow
# @brief Underflow ΥХå饹(֥饹)
#
# @since 0.4.0
#
# InPort/OutPortΥХåե˥ǡread()ˡɤ߽Ф٤ǡ
# ʤ˸ƤӽФ륳Хå󥿥ե
# ΥХåͤread()ͤȤʤ롣<BR>
# ֥饹Ǥμ
#
# @else
# @class OnUnderflow
# @brief OnUnderflow abstract class
#
# @endif
class OnUnderflow:
  def __call__(self,value):
    pass
