#!/usr/bin/env python
# -*- coding: euc-jp -*-

##
# @file  PublisherNew.py
# @brief PublisherNew class
# @date  $Date: 2007/09/27 $
# @author Noriaki Ando <n-ando@aist.go.jp> and Shinji Kurihara
#
# Copyright (C) 2006-2008
#     Noriaki Ando
#     Task-intelligence Research Group,
#     Intelligent Systems Research Institute,
#     National Institute of
#         Advanced Industrial Science and Technology (AIST), Japan
#     All rights reserved.
 
import threading

import OpenRTM


##
# @if jp
# @class PublisherNew
# @brief PublisherNew 饹
#
# Хåե˿ǡǼ줿ߥ󥰤ǡοǡ롣
# ǡХߥ󥰤Ԥĥ󥷥塼ޤФ¦Ȥϰۤʤ륹åɤ
# ư˻ѡ
# PublisherζưϡǡФΥߥ󥰤ˤʤޤǥ֥å졢
# Хߥ󥰤Τȡ¨¤˥󥷥塼ޤнƤӽФ
#
# @else
# @class PublisherNew
# @brief PublisherNew class
# @endif
class PublisherNew(OpenRTM.PublisherBase):
  """
  """



  ##
  # @if jp
  # @brief 󥹥ȥ饯
  #
  # 󥹥ȥ饯
  #  Publisher ѿåɤ롣
  #
  # @param self
  # @param consumer ǡФԤĥ󥷥塼
  # @param property PublisherζưꤷProperty֥
  #                 (PublisherǤ̤)
  # @else
  # @brief Constructor
  # @endif
  def __init__(self, consumer, property):
    self._data = self.NewData()
    self._consumer = consumer
    self._running = True
    self._thread = threading.Thread(target=self.run)
    self._thread.start()


  ##
  # @if jp
  # @brief ǥȥ饯
  #
  # ǥȥ饯
  #
  # @param self
  #
  # @else
  # @brief Destructor
  #
  # @endif
  def __del__(self):
    del self._consumer


  ##
  # @if jp
  # @brief Observerؿ
  #
  # Хߥ󥰻˸ƤӽФ
  # ֥åƤPublisherζưϤ졢󥷥塼ޤؤн
  # Ԥ롣
  #
  # @param self
  #
  # @else
  # @brief Observer function
  # @endif
  def update(self):
    if not self._data._cond.acquire(0):
      return

    self._data._updated = True
    self._data._cond.notify()
    self._data._cond.release()
    return


  ##
  # @if jp
  # @brief ϴؿ
  #
  # Publisherưѥåɤμ¹Ԥ򳫻Ϥ롣
  #
  # @param self
  #
  # @else
  # @brief Thread execution function
  # @endif
  def run(self):
    while self._running:
      self._data._cond.acquire()
      # Waiting for new data updated
      while not self._data._updated and self._running:
        self._data._cond.wait()

      if self._data._updated:
        self._consumer.push()
        self._data._updated = False

      self._data._cond.release()


  ##
  # @if jp
  # @brief λؿ
  #
  # ACE_Task::release() ΥС饤
  # ưե饰falseꤷ Publisher ζưߤ롣
  # ưåɤ֥åƤˤϡ
  # 磱󥳥󥷥塼ޤнƤӽФ礬롣
  #
  # @param self
  #
  # @else
  # @brief Task terminate function
  #
  # ACE_Task::release() override function
  #
  # @endif
  def release(self):
    if not self._data._cond.acquire(0):
      return

    self._running = False
    self._data._cond.notify()
    self._data._cond.release()
    #self.wait()


  # NewData condition struct
  ##
  # @if jp
  # @class NewData
  # @brief ǡִ饹
  # @else
  # @endif
  class NewData:
    def __init__(self):
      self._mutex = threading.RLock()
      self._cond = threading.Condition(self._mutex)
      self._updated = False
