#!/usr/bin/env python
# -*- coding: euc-jp -*-

##
# @file RingBuffer.py
# @brief Defautl Buffer class
# @date $Date: 2007/09/12 $
# @author Noriaki Ando <n-ando@aist.go.jp> and Shinji Kurihara
#
# Copyright (C) 2006-2008
#     Noriaki Ando
#     Task-intelligence Research Group,
#     Intelligent Systems Research Institute,
#     National Institute of
#         Advanced Industrial Science and Technology (AIST), Japan
#     All rights reserved.

import RTC
import OpenRTM

##
# @if jp
# @class RingBuffer
# @brief 󥰥Хåե饹
# 
# ꤷĹΥ󥰾ХåեĥХåե饹
# ХåեΤ˥ǡǼ줿硢ʹߤΥǡϸŤǡ
# 缡񤭤롣
# äơХåեˤľΥХåեĹʬΥǡΤݻ롣
#
# )ߤμǤϡֺǸ˳ǼǡΤߥХåեɤ߽Фǽ
#
# @param DataType Хåե˳Ǽǡ
#
# @since 0.4.0
#
# @else
#
# @endif
class RingBuffer(OpenRTM.BufferBase):
  """
  """



  ##
  # @if jp
  #
  # @brief 󥹥ȥ饯
  # 
  # 󥹥ȥ饯
  # ꤵ줿ХåեĹǥХåե롣
  # ꤵ줿Ĺ̤ξ硢ĹǥХåե롣
  #
  # @param self
  # @param length ХåեĹ
  # 
  # @else
  #
  # @endif
  def __init__(self, length):
    self._oldPtr = 0
    if length < 2:
      self._length = 2
      self._newPtr = 1
    else:
      self._length = length
      self._newPtr = length - 1

    self._inited = False
    self._buffer = [self.Data() for i in range(self._length)]


  ##
  # @if jp
  #
  # @brief 
  # 
  # Хåեν¹Ԥ롣
  # ꤵ줿ͤХåեΤ˳Ǽ롣
  #
  # @param self
  # @param data ѥǡ
  # 
  # @else
  #
  # @endif
  def init(self, data):
    for i in range(self._length):
      self.put(data)


  ##
  # @if jp
  #
  # @brief ꥢ
  # 
  # Хåե˳Ǽ줿򥯥ꥢ롣
  #
  # @param self
  # 
  # @else
  #
  # @endif
  def clear(self):
    self._inited = False


  ##
  # @if jp
  #
  # @brief ХåեĹ
  # 
  # ХåեĹ롣
  #
  # @param self
  # 
  # @return ХåեĹ
  # 
  # @else
  #
  # @brief Get the buffer length
  #
  # @endif
  def length(self):
    return self._length


  ##
  # @if jp
  #
  # @brief Хåե˽񤭹
  # 
  # Ϳ줿ǡХåե˽񤭹ࡣ
  # 
  # @param self
  # @param value 񤭹оݥǡ
  #
  # @return ǡ񤭹߷(true:񤭹֤)
  # 
  # @else
  #
  # @brief Write data into the buffer
  #
  # @endif
  def write(self, value):
    self.put(value)
    return True


  ##
  # @if jp
  #
  # @brief Хåեɤ߽Ф
  # 
  # Хåե˳Ǽ줿ǡɤ߽Ф
  # 
  # @param self
  # @param value ɤ߽Фǡ
  #
  # @return ǡɤ߽Ф
  # 
  # @else
  #
  # @brief Write data into the buffer
  #
  # @endif
  def read(self, value):
    if not self._inited:
      return False
    value[0] = self.get()
    return True


  ##
  # @if jp
  #
  # @brief ХåեդǤ뤫ǧ
  # 
  # Хåեդǧ롣(false֤)
  # 
  # @param self
  #
  # @return ճǧ(false)
  # 
  # @else
  #
  # @brief True if the buffer is full, else false.
  #
  # @endif
  def isFull(self):
    return False


  ##
  # @if jp
  #
  # @brief ХåեǤ뤫ǧ
  # 
  # Хåեǧ롣
  # 
  # )ߤμǤϡߤΥХåե֤˳Ǽ줿ǡɤ߽Ф줿
  # ɤ֤( true:ǡɤ߽Фѡfalse:ǡ̤ɤ߽Ф)
  # 
  # @param self
  #
  # @return ǧ
  # 
  # @else
  #
  # @brief True if the buffer is empty, else false.
  #
  # @endif
  def isEmpty(self):
    return not self._inited


  ##
  # @if jp
  #
  # @brief ǿǡǧ
  # 
  # ߤΥХåե֤˳ǼƤǡǿǡǧ롣
  # 
  # @param self
  #
  # @return ǿǡǧ
  #           ( true:ǿǡǡϤޤɤ߽ФƤʤ
  #            false:Υǡǡϴɤ߽ФƤ)
  # 
  # @else
  #
  # @endif
  def isNew(self):
    return self._buffer[self._newPtr].isNew()


  ##
  # @if jp
  #
  # @brief Хåե˥ǡǼ
  # 
  # Ϳ줿ǡХåե˳Ǽ롣
  # 
  # )ߤμǤϥǡǼƱˡǡɤ߽Ф֤
  # Ǽǡ֤ꤷƤ롣Τᡢľ˳Ǽǡ
  # ȤʤäƤ롣
  # 
  # @param self
  # @param data Ǽоݥǡ
  # 
  # @else
  #
  # @brief Write data into the buffer
  #
  # @endif
  def put(self, data):
    self._buffer[self._oldPtr].write(data)
    self._newPtr = self._oldPtr
    ptr = self._oldPtr + 1
    self._oldPtr = ptr % self._length
    self._inited = True


  ##
  # @if jp
  #
  # @brief Хåեǡ
  # 
  # Хåե˳Ǽ줿ǡ롣
  # 
  # @param self
  #
  # @return ǡ
  # 
  # @else
  #
  # @brief Get data from the buffer
  #
  # @endif
  def get(self):
    return self._buffer[self._newPtr].read()


  ##
  # @if jp
  #
  # @brief ˽񤭹ХåեؤλȤ
  # 
  # 񤭹ߥХåեؤλȤ롣
  # 
  # @return ν񤭹оݥХåեؤλ
  # 
  # @param self
  #
  # @else
  #
  # @brief Get the buffer's reference to be written the next
  #
  # @endif
  def getRef(self):
    return self._buffer[self._newPtr].data


  ##
  # @if jp
  # @class Data
  # @brief Хåեǡ饹
  # 
  # ХåեǡǼ󥯥饹
  #
  # @since 0.4.0
  #
  # @else
  # @brief Buffer sequence
  # @endif
  class Data:
    def __init__(self):
      self.data = None
      self.is_new = False


    def write(self, other):
      self.is_new = True
      self.data = other


    def read(self):
      self.is_new = False
      return self.data


    def isNew(self):
      return self.is_new
